TEMPLATE = app
CONFIG += console
CONFIG -= app_bundle
CONFIG -= qt

SOURCES += bu2kstarmumu.cc \
    sources/Core/bu2kstarmumu_generator.cc \
    sources/Core/bu2kstarmumu_loader.cc \
    sources/Core/bu2kstarmumu_parameters.cc \
    sources/Core/bu2kstarmumu_pdf.cc \
    sources/Core/bu2kstarmumu_plotter.cc \
    sources/Core/event.cc \
    sources/Core/fitter.cc \
    sources/Core/folder.cc \
    sources/Core/funcs.cc \
    sources/Core/integrals.cc \
    sources/Core/options.cc \
    sources/Core/toystudy.cc \
    sources/Helpers/design.cc \
    sources/Helpers/helpers.cc \
    sources/Params/constants.cc \
    sources/Params/parameters.cc \
    sources/Params/parameterscan.cc \
    sources/Run/angularcorr.cc \
    sources/Run/backgroundfit.cc \
    sources/Run/feldman_cousins.cc \
    sources/Run/generatetoys.cc \
    sources/Run/genlvlfit.cc \
    sources/Run/likelihoodscan.cc \
    sources/Run/mainfit.cc \
    sources/Run/massfit.cc \
    sources/Run/mcfit.cc \
    sources/Run/momfit.cc \
    sources/Run/multifit.cc \
    sources/Run/pulls.cc \
    sources/Run/toysfit.cc \
    sources/Scripts/GenLvlvsMC.cc \
    sources/Scripts/GetMeanError.cc \
    sources/Scripts/PlotMCfit.cc \
    sources/Scripts/ReferencePlots.cc \
    sources/Scripts/RunningScripts.cc \
    sources/Scripts/ScriptHelpers.cc \
    sources/Scripts/EvaluateToys.cc \
    sources/help.cc \
    sources/parse.cc \
    sources/paths.cc \
    sources/tests.cc

HEADERS += sources/Core/bu2kstarmumu_generator.hh \
    sources/Core/bu2kstarmumu_loader.hh \
    sources/Core/bu2kstarmumu_parameters.hh \
    sources/Core/bu2kstarmumu_pdf.hh \
    sources/Core/bu2kstarmumu_plotter.hh \
    sources/Core/event.hh \
    sources/Core/fitter.hh \
    sources/Core/folder.hh \
    sources/Core/funcs.hh \
    sources/Core/generator.hh \
    sources/Core/integrals.hh \
    sources/Core/options.hh \
    sources/Core/pdf.hh \
    sources/Core/plotter.hh \
    sources/Core/toystudy.hh \
    sources/Helpers/colors.hh \
    sources/Helpers/design.hh \
    sources/Helpers/helpers.hh \
    sources/Params/constants.hh \
    sources/Params/parameters.hh \
    sources/Params/parameterscan.hh \
    sources/Params/values.hh \
    sources/Run/angularcorr.hh \
    sources/Run/backgroundfit.hh \
    sources/Run/feldman_cousins.hh \
    sources/Run/generatetoys.hh \
    sources/Run/genlvlfit.hh \
    sources/Run/likelihoodscan.hh \
    sources/Run/mainfit.hh \
    sources/Run/massfit.hh \
    sources/Run/mcfit.hh \
    sources/Run/momfit.hh \
    sources/Run/multifit.hh \
    sources/Run/pulls.hh \
    sources/Run/toysfit.hh \
    sources/Scripts/GenLvlvsMC.hh \
    sources/Scripts/GetMeanError.hh \
    sources/Scripts/PlotMCfit.hh \
    sources/Scripts/ReferencePlots.hh \
    sources/Scripts/RunningScripts.hh \
    sources/Scripts/ScriptHelpers.hh \
    sources/Scripts/EvaluateToys.hh \
    sources/help.hh \
    sources/parse.hh \
    sources/paths.hh \
    sources/tests.hh

INCLUDEPATH +=/home/renata/B2KMuMu/sigma0/B2KstarMuMu/code/ewp-Bplus2Kstmumu-AngAna/FCNCfitter/sources/
INCLUDEPATH +=/home/renata/B2KMuMu/sigma0/B2KstarMuMu/code/ewp-Bplus2Kstmumu-AngAna/FCNCfitter/sources/Core/
INCLUDEPATH +=/home/renata/B2KMuMu/sigma0/B2KstarMuMu/code/ewp-Bplus2Kstmumu-AngAna/FCNCfitter/sources/Helpers/
INCLUDEPATH +=/home/renata/B2KMuMu/sigma0/B2KstarMuMu/code/ewp-Bplus2Kstmumu-AngAna/FCNCfitter/sources/Params/
INCLUDEPATH +=/home/renata/B2KMuMu/sigma0/B2KstarMuMu/code/ewp-Bplus2Kstmumu-AngAna/FCNCfitter/sources/Run/
INCLUDEPATH +=/home/lhcb/kopecna/B2KstarMuMu/code/spdlog/include/spdlog/

unix: CONFIG += link_pkgconfig
unix: PKGCONFIG += /usr/local/root/build/lib/pkgconfig/liblzma.pc
