#!/bin/sh

# LHCb group_login.sh destroy arguments...
ProcID="$1"
ClusterID="$2"

# If something from there is required...
source /cvmfs/lhcb.cern.ch/group_login.sh

# real job (since I work in my directory, I have to set path explicity)
from_dir=/home/lhcb/kopecna/B2KstarMuMu/code/ewp-Bplus2Kstmumu-AngAna/FCNCfitter

#That can work, with a bit of luck...
# source $FROM_DIR/SetPaths.sh
#
# But there are more standard and so stable way to setup CVMFS environment.
# For "generic CERN" (not LHCb specific):
#  The list of possible views:
#    source /cvmfs/sft.cern.ch/lcg/views/setupViews.sh gives the list..
#  The list of binary tags for views:
#    source /cvmfs/sft.cern.ch/lcg/views/setupViews.sh <view>
# And so, for LCG_84 and x86_64-slc6-gcc49-opt
source /cvmfs/sft.cern.ch/lcg/views/setupViews.sh LCG_84 x86_64-slc6-gcc49-opt
echo "Job execution OS: `/work/software/os_version`"
echo "Args: '$ProcID' '$ClusterID'"

#$from_dir/bu2kstarmumu -r 12 -d 0 -u 1 -q -w -e 13000 -j $ProcID -i $ClusterID -v 3
#$from_dir/bu2kstarmumu -r 12 -d 0 -u 1 -q -w -e 52000 -j $ProcID -i $ClusterID -v 3
$from_dir/bu2kstarmumu -r 12 -d 0 -u 1 -q -w -e 65000 -j $ProcID -i $ClusterID -v 3
#$from_dir/bu2kstarmumu -r 12 -d 0 -u 5 -w -e 8710 -j $ProcID -i $ClusterID -v 3
#$from_dir/bu2kstarmumu -r 12 -d 0 -u 5 -w -e 871 -j $ProcID -i $ClusterID -v 3

