/**
 * @file generator.hh
 * @author Christoph Langenbruch, Renata Kopecna
 * @date 2009-03-18
 *
 */

#ifndef GENERATOR_H
#define GENERATOR_H

#include <pdf.hh>
#include <parameters.hh>

namespace fcnc {

///An abstract base class for toy monte carlo generators
class generator {
public:
  ///generates nevents toy monte carlo events
  virtual std::vector<event> generate(unsigned int nevents, parameters* parameters, pdf* probability)=0;
};

}

#endif

