/**
 * @file plotter.hh
 * @author Christoph Langenbruch, Renata Kopecna

 * @date 2009-03-18
 *
 */

#ifndef PLOTTER_H
#define PLOTTER_H

#include <string>
#include <vector>

namespace fcnc {
    class pdf;
    class event;
    class parameters;

///abstract base class that defines the interface for a plotter
///your plotter needs to inherit form this and implement all the abstract methods
class plotter {
public:
  virtual ~plotter() {};
  ///plots the pdf projections 
  virtual int plot_data(pdf* prob, parameters* params, std::vector<event>* ev, std::string index) = 0;

};

}

#endif
